<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" :size="ELsize" label-width="auto">
      <el-form-item label="快递公司名称" prop="companyName">
        <el-input v-model="queryParams.companyName" maxlength="30" placeholder="请输入快递公司名称" clearable
          @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="快递公司编码" prop="companyCode">
        <el-input v-model="queryParams.companyCode" maxlength="30" placeholder="请输入快递公司编码" clearable
          @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="快递公司电话" prop="companyPhone">
        <el-input v-model="queryParams.companyPhone" placeholder="请输入快递公司电话" maxlength="11" clearable
          @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" :size="ELsize" @click="handleAdd">新增</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :border="TableBorder" :size="ELTableSize" :data="list"
      @selection-change="handleSelectionChange">
      <el-table-column type="index" width="55" label="序号" align="center">
        <template slot-scope="{$index}">
          {{ $getTableIndex(queryParams, $index + 1) }}
        </template>
      </el-table-column>
      <el-table-column label="快递公司名称" align="center" prop="companyName" />
      <el-table-column label="快递公司编码" align="center" prop="companyCode" />
      <el-table-column label="快递公司电话" align="center" prop="companyPhone" />
      <el-table-column label="排序" align="center" prop="sort" />
      <!-- <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column> -->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button :size="ELTableSize" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)">修改</el-button>
          <el-button :size="ELTableSize" type="text" icon="el-icon-delete"
            @click="handleDelete(scope.row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改测试单表对话框 -->
    <el-drawer :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px" :size="ELsize">
        <el-form-item label="快递公司名称" prop="companyName">
          <el-input v-model="form.companyName" maxlength="30" placeholder="请输入快递公司名称" />
        </el-form-item>
        <el-form-item label="快递公司编码" prop="companyCode">
          <el-input v-model="form.companyCode" maxlength="30" placeholder="请输入快递公司编码" />
        </el-form-item>
        <el-form-item label="快递公司电话" prop="companyPhone">
          <el-input v-model="form.companyPhone" maxlength="60" placeholder="请输入快递公司电话" />
        </el-form-item>
        <el-form-item label="排序" prop="sort">
          <el-input-number v-model="form.sort" :min="1" label="排序" :precision="0"></el-input-number>
        </el-form-item>
      </el-form>
      <div class="demo-drawer__footer">
        <el-button :size="ELsize" :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
        <el-button :size="ELsize" @click="cancel">取 消</el-button>
      </div>
    </el-drawer>
    <!-- 用户导入对话框 -->
  </div>
</template>

<script>
import { expressCompanyAdd, expressCompanyEdit, expressCompanyPage, expressCompanyInfo, expressCompanyDel } from "@/api/operating.js";

export default {
  dicts: ['quick_link_location'],
  components: {
  },
  data() {
    return {
      //按钮loading
      buttonLoading: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 测试单表表格数据
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 创建时间时间范围
      daterangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        companyName: undefined,
        companyCode: undefined,
        companyPhone: undefined
      },
      // 表单参数
      form: {
        companyName: undefined,
        companyCode: undefined,
        companyPhone: undefined,
        sort: 1
      },
      // 表单校验
      rules: {
        companyName: [
          { required: true, message: "请输入快递公司名称", trigger: "blur" }
        ],
        companyCode: [
          { required: true, message: "请输入快递公司编码", trigger: "blur" }
        ],
        companyPhone: [
          { required: true, message: "请输入快递公司电话", trigger: "blur" }
        ],
        sort: [
          { required: true, message: "请输入排序", trigger: "blur" }
        ],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询测试单表列表 */
    getList() {
      this.loading = true;
      this.queryParams["createTimeStart"] = undefined;
      this.queryParams["createTimeEnd"] = undefined;
      if (null != this.daterangeCreateTime && '' != this.daterangeCreateTime) {
        this.queryParams["createTimeStart"] = this.daterangeCreateTime[0] + ' 00:00:00';
        this.queryParams["createTimeEnd"] = this.daterangeCreateTime[1] + ' 23:59:59';
      }
      expressCompanyPage(this.queryParams).then(response => {
        this.list = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    handleResourceTip(type) {
      for (let item of this.resourceTip) {
        if (type == item.value) {
          return item.label || "";
        }
      }
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        companyName: undefined,
        companyCode: undefined,
        companyPhone: undefined,
        sort: 1
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.daterangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.loading = true;
      this.reset();
      const id = row.id || this.ids
      expressCompanyInfo(id).then(response => {
        this.loading = false;
        this.form = response.data;
        this.open = true;
        this.title = "修改";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.buttonLoading = true;
          if (this.form.id != null) {
            expressCompanyEdit(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          } else {
            expressCompanyAdd(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除快递公司名称为"' + row.companyName + '"的数据项？').then(() => {
        this.loading = true;
        return expressCompanyDel(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).finally(() => {
        this.loading = false;
      });
    },
    /** 上下架按钮操作 */
    setStatus(row) {
      const ids = row.id || this.ids;
      let statusText = row.status ? '下架' : '上架';
      this.$modal.confirm('是否确认' + statusText + '金刚区名称为"' + row.companyName + '"的数据项？').then(() => {
        this.loading = true;
        return quickLinkSetStatus(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess(statusText + "成功");
      }).finally(() => {
        this.loading = false;
      });
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户导入";
      this.upload.open = true;
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('demo/demo/export', {
        ...this.queryParams
      }, `demo_${new Date().getTime()}.xlsx`)
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    }
  }
};
</script>
<style lang="scss">
.el-drawer__body {
  padding: 0 20px !important;
}
</style>
<style lang="scss" scoped>
.flex {
  display: flex;
}

.demo-drawer__footer {
  margin-left: 120px;
}
</style>
